// Author: Professor William Killian
// Date: 2019 July
// Class: CSCI 362.93 - Data Structures
// Assignment: 8 - Graph Algorithms
//
// Description:
//
// A subset of graph algorithms which operate on
// graphs represented with an adjacency list

#include "GraphAlgorithms.hpp"
#include "DisjointSet.hpp"
#include "MinHeap.hpp"

#include <algorithm>
#include <queue>
#include <stack>

namespace GraphUtils
{

std::vector<size_t>
bfs (Graph const& g, size_t start)
{
  std::vector<size_t> output;
  // TODO

  return output;
}

std::vector<size_t>
dfs (Graph const& g, size_t start)
{
  std::vector<size_t> output;
  // TODO

  return output;
}

std::vector<size_t>
topological_sort (Graph const& g)
{
  std::vector<size_t> output;
  // TODO

  // compute indegree

  // initialized queue

  // process queue

  return output;
}

EdgeList
prims (Graph const& g, size_t start)
{
  EdgeList edges;

  std::unordered_map<size_t, size_t> prev;
  std::unordered_set<size_t> known;

  // TODO

  // populate priority queue

  // decrease key on "start"

  // while we haven't seen all the nodes
  //   extract min
  //   add to output
  //   for each edge (u,v)=w:
  //     if unseen v:
  //       if decrease_key (w, v):
  //         update prev[v] = u

  return edges;
}

EdgeList
kruskals (Graph const& g)
{
  DisjointSet uf (g.size ());
  EdgeList edges;

  EdgeList all_edges = g.edges ();

  // TODO

  // sort all_edges
  // for each edge (u,v)=w:
  //   if !sameSet(u,v):
  //     unionSet(u,v)
  //     add edge to output
  //     if size of disjoint set == 1:
  //       break

  return edges;
}

//
// Shortest Path Algorithms
//
// - edges returns should be constructed (made) from the "prev"
//   vertex, the current vertex, and the "dist" weight calculated
// - use unordered_map<size_t, TYPE> for the "dist" and "prev" arrays
// - remember to initialize all "dist" to std::numeric_limits<double>::max()
//
// (Dijkstra only)
// - Create an unordered_set to keep track of logically removed vertices

EdgeList
dijkstra (Graph const& g, size_t start)
{
  EdgeList edges;
  std::unordered_set<size_t> seen;
  std::unordered_map<size_t, size_t> prev;
  MinHeap<DistanceVertexPair> pq;

  // insert all vertices into pq
  // decrease_key of start to 0.0

  // while the pq isn't empty:
  //   extract the min
  //   insert the min node into seen
  //   add (prev[u], u, dist[u]) to edges
  //   for each adjacent edge to u  (u,v)=w
  //     if we haven't seen v:
  //       if decreasing key by dist_u + w makes v's distance smaller:
  //         update prev[v] to u

  return edges;
}

EdgeList
bellman_ford (Graph const& g, size_t start)
{
  EdgeList edges;
  // TODO

  std::unordered_map<size_t, double> dist;
  std::unordered_map<size_t, size_t> prev;

  // initialize dist and prev arrays
  // set dist[start] to 0.0

  // |V|*|E| relaxations -- remember to update prev when relaxing

  // check for convergence

  // build edge lists (prev[v], v, dist[v])

  return edges;
}

}
